/*
 * supervisor.hpp
 *
 *  Created on: Jan 6, 2024
 *      Author: Dario
 */

#ifndef STA_TASTY_TASKS_SUPERVISOR_HPP
#define STA_TASTY_TASKS_SUPERVISOR_HPP

#include <sta/tacos/thread.hpp>

#include <list>
#include <functional>

namespace sta
{
    namespace tasty
    {
        typedef std::function<void(void)> TastyCheck;

        class Supervisor : public tacos::TacosThread
        {
        public:
            Supervisor(std::list<TastyCheck> checks);

            void func() override;
        private:
            std::list<TastyCheck> checks_;
        };
    } // namespace tasty
} // namespace sta




#endif // STA_TASTY_TASKS_SUPERVISOR_HPP
