#include <sta/tasty/utils.hpp>

#ifdef STA_DEBUGGING_ENABLED

#include <sta/debug/debug.hpp>
#include <sta/devices/stm32/delay.hpp>

namespace sta
{
    namespace tasty
    {
    	void test_init()
    	{
    		sta::delayMs(10);
    	}

        void test_case(const char * file, uint32_t line, bool rslt)
        {
            STA_DEBUG_PRINTF("[%s|%d|%d]", file, line, rslt);
        }

        void test_terminate()
        {
            STA_DEBUG_PRINTLN("[T]");

            while (true) {}
        }
    } // namespace tasty    
} // namespace sta

#endif // STA_DEBUGGING_ENABLED
